<?php
//blocking direct access the file
if ( ! defined( 'ABSPATH' ) ) {
    die( '&ldquo;the door is shut it was made by those who are dead&rdquo;' );
}
class GBFLead{
    private $settings;
    private $lead_id;
    private $form_id;
    private $fields;
    private $values;
    private $original_fields;
    private $status;
    private $name;
    private $meta;
    private $type;
    private $sent;
    private $is_ready_to_send;

    /**
     * @param boolean $sent
     */
    private function setSent($sent = false)
    {
        $this->sent = $sent;
    }

    function __construct($post_id){
        //calling the class with post id
        if(is_numeric($post_id)){
            $this->settings = $this->Settings();

            $this->init($post_id);
        }else{
            return false;
        }
        return true;
    }

    //PRIVATE

    /*
     * call : * in class
     * do : return array of settings
     */
    private function Settings(){
        $out = array(
            'option' => 'gbfdb_lead_fields',
            'meta' => array(
                'original_fields' => 'gbfdb_lead_original_fields',
            ),
            'filters' => array(
                'LeadMeta' => 'gbfdb_check_lead_meta',
                'LeadFields' =>  'gbfdb_check_lead_fields',
            )
        );
        return $out;
    }

    /*
     * call : __construct
     * do : Initiate the class
     */
    private function init($lead_id){
        $form_id = get_post_meta( $lead_id, $this->settings["option"]."_id" ,true);
        $status = get_post_meta( $lead_id, $this->settings["option"]."_status" ,true);
        $name = get_post_meta( $lead_id, $this->settings["option"]."_name" ,true);
        $meta = get_post_meta( $lead_id, $this->settings["option"]."_meta" ,true);
        $fields = get_post_meta( $lead_id, $this->settings["option"] ,true);
        $type = get_post_meta( $lead_id, $this->settings["option"]."_type" ,true);
        $sent = get_post_meta( $lead_id, $this->settings["option"]."_sent" ,true);
        $this->original_fields = get_post_meta($this->lead_id,$this->settings['meta']['original_fields'],true);

        if($lead_id && is_numeric($lead_id))
            $this->setLeadId($lead_id);

        if($form_id)
            $this->setFormId($form_id);

        if($meta)
            $this->setMeta($meta);

        if($status)
            $this->setStatus($status);

        if($name)
            $this->setName($name);

        if($fields)
            $this->setFields($fields);

        if($sent)
            $this->setSent($sent);

        if($type){
            $this->setType($type);
        }else{
            $this->type = $this->getType();
        }
    }


    /**
     * @param mixed $meta
     */
    private function setMeta($meta)
    {
        $this->meta = $meta;
    }

    //PUBLIC

    /**
     * @return boolean
     */
    public function is_loaded()
    {
        $is_load = true;

        if(!is_numeric($this->lead_id)){
            $is_load = false;
        }

        if($is_load && (empty($this->form_id || !is_string($this->form_id)))){
            $is_load = false;
        }

        if($is_load && (empty($this->fields || !is_array($this->fields)))){
            $is_load = false;
        }

        if($is_load && (empty($this->values || !is_array($this->values)))){
            $is_load = false;
        }

        if($is_load && (empty($this->name || !is_string($this->name)))){
            $is_load = false;
        }

        if($is_load && (empty($this->meta || !is_array($this->meta)))){
            $is_load = false;
        }

        if($is_load && (empty($this->type || !is_string($this->meta)))){
            $is_load = false;
        }

        return $is_load;
    }

    /**
     * @return mixed
     */
    public function getLeadId()
    {
        return $this->lead_id;
    }

    /**
     * @param mixed $lead_id
     */
    public function setLeadId($lead_id)
    {
        $this->lead_id = intval($lead_id);
    }

    /**
     *
     */
    public function is_ready_to_send()
    {
        return $this->is_ready_to_send;
    }

    /**
     * @return mixed
     */
    public function getFormId()
    {
        return $this->form_id;
    }

    /**
     * @param mixed $form_id
     */
    public function setFormId($form_id)
    {
        $this->form_id = $form_id;
    }

    /**
     * @return mixed
     */
    public function getFields()
    {
        $lead_fields = apply_filters($this->settings['filters']['LeadFields'],$this->fields,$this->name,$this->type);
        return $lead_fields;
    }

    /**
     * @param mixed $fields
     */
    public function setFields($fields)
    {
        $this->fields = $fields;
    }

    /**
     * @return mixed
     */
    public function getValues()
    {
        return $this->values;
    }

    /**
     * @param mixed $values
     */
    public function setValues($values)
    {
        $this->values = $values;
    }

    /**
     * @return mixed
     */
    public function getOriginalFields()
    {
        if(empty($this->original_fields)){
            $this->original_fields = get_post_meta($this->lead_id,$this->settings['meta']['original_fields'],true);
        }
        return $this->original_fields;
    }

    /**
     * @param array $original_fields
     */
    public function setOriginalFields($original_fields = array())
    {
        if(is_array($original_fields) && !empty($original_fields)){
            if($original_fields != $this->original_fields)
            update_post_meta($this->lead_id,$this->settings['meta']['original_fields'],$original_fields);
            $this->original_fields = $original_fields;
        }
    }

    /**
     * @return mixed
     */
    public function getStatus($print = false)
    {
        if($print){
            $output = array();
            $output['settings'] = $this->settings;
            $output['lead_id'] = $this->lead_id;
            $output['form_id'] = $this->form_id;
            $output['fields'] = $this->fields;
            $output['values'] = $this->values;
            $output['original_fields'] = $this->original_fields;
            $output['status'] = $this->status;
            $output['name'] = $this->name;
            $output['meta'] = $this->meta;
            $output['type'] = $this->type;
            $output['sent'] = ($this->sent ? 'true' : 'false');
            return $output;
        }
        return $this->status;
    }

    /**
     * @param mixed $status
     */
    public function setStatus($status)
    {
        $this->status = $status;
        update_post_meta( $this->lead_id, $this->settings["option"]."_status",esc_attr($status));
    }

    /**
     * @return mixed
     */
    public function getName()
    {
        return $this->name;
    }

    /**
     * @param mixed $name
     */
    public function setName($name)
    {
        $this->name = $name;
    }

    /**
     * @return mixed
     */
    public function getMeta()
    {
        return apply_filters($this->settings['filters']['LeadMeta'],$this->meta,$this->name);
    }

    /**
     * @return mixed
     */
    public function getType()
    {
        if(!$this->type){
            if($this->name){
                $temp_name = substr($this->name,strlen('gbfdb_record_'));
                if($temp_name){
                    $this->type = substr($temp_name,0,strpos($temp_name,'_'));
                }
            }
            if(!$this->type){
                $this->type = 'undefined';
            }
            update_post_meta( $this->lead_id, $this->settings["option"]."_type" ,$this->type);
        }
        return $this->type;
    }

    /**
     * @param mixed $type
     */
    public function setType($type)
    {
        $this->type = $type;
    }

    /**
     * @return boolean
     */
    public function getSent()
    {
        return $this->sent;
    }

}