<?php
// no access directly
if ( ! defined( 'ABSPATH' ) ) {
    die( '&ldquo;the door is shut it was made by those who are dead&rdquo;' );
}

if( !class_exists('GBFLeads') ):
    class GBFLeads{
        private $settings;
        function __construct(){
            add_action( "current_screen", array($this,"get_current_screen") );

            $this->settings = $this->GetGBProductSettings();

            $this->init();

            $this->hooks();

        }

        //PRIVATE

        /*
         * call : * in class
         * do : return array of settings
         */
        private function GetGBProductSettings(){
            return array(
                'id' => 'gbf-leads',
                'slug' => 'leads',
                'option' => 'gbfdb_lead_fields',
                'title' => __('Form leads','gbgm'),
                'singular' => __('Form lead','gbgm'),
            );
        }

        /*
         * call : __construct
         * do : Initiate the class
         */
        private function init(){
        }

        /*
         * call : __construct
         * do : Initiate the class
         */
        private function get_leads_nav($all_leads){
            if($all_leads):?>
                <ul class="gbfdb-leads-nav-list">
                    <li class="gbfdb-leads-nav-list-item first-row">
                        <div class="field-wrap gbfdb-checkbox">
                            <label><input type="checkbox" id="show_system_fields"> <?php _e("Show system fields","gb-forms-db"); ?></label>
                        </div>
                        <div class="field-wrap gbfdb-action">
                            <form id="gbfdb-action-form" method="post">
                                <select name="gbfdb-action" class="gbfdb-action-select">
                                    <option><?php echo __("Action","gb-forms-db"); ?></option>
                                    <option value="delete"><?php echo __("Delete","gb-forms-db"); ?></option>
                                </select>
                                <button type="submit" class="gb_button-disable gb_button gbfdb-do-action"><?php echo __("Apply","gb-forms-db") ?></button>
                                <input type="hidden" name="gbfdb_selected_ids" id="gbfdb_selected_ids" value="">
                                <?php wp_nonce_field( 'gbfdb-action-nonce', 'gbfdb_action_sod' ); ?>
                            </form>
                        </div>
                        <div class="field-wrap gbfdb-cvs">
                            <select id="gbfdb-cvs-forms" class="gbfdb-cvs-forms"><option><?php echo __("Select form ID","gb-forms-db") ?></option></select>
                            <a href="#" class=" gb_button-disable gb_button gbfdb-leads-cvs"><?php echo __("Save Form as CSV","gb-forms-db") ?></a>
                        </div>
                    </li>
                    <li class="gbfdb-leads-nav-list-item gbfdb-checkbox">
                        <div class="field-wrap gbfdb-checkbox">
                            <label><input type="checkbox" id="gbfdb-select-all"> <?php _e("Select all","gb-forms-db"); ?></label>
                        </div>
                    </li>
                    <li class="gbfdb-leads-nav-list-item field-view-period">
                        <div class="field-wrap gbfdb-view-period">
                            <label class="gbfdb-nav-title"><?php echo esc_html(__("Period","gb-forms-db")); ?></label>
                            <div class="field-con">
                                <select class="gbfdb-field" id="gbfdb-view-period" name="gbfdb-view-period">
                                    <option></option>
                                    <option value="1"><?php echo esc_html(__("1 - Month","gb-forms-db")); ?></option>
                                    <option value="3"><?php echo esc_html(__("3 - Month","gb-forms-db")); ?></option>
                                    <option value="6"><?php echo esc_html(__("6 - Month","gb-forms-db")); ?></option>
                                    <option value="12"><?php echo esc_html(__("1 - Year","gb-forms-db")); ?></option>
                                    <option value="period"><?php echo esc_html(__("Time Period","gb-forms-db")); ?></option>
                                </select>
                                <a href="#" class=" gb_button-green gb_button dashicons dashicons-search gbfdb-search"></a>
                            </div>
                        </div>
                    </li>
                    <li class="gbfdb-leads-nav-list-item field-date">
                        <div class="field-wrap gbfdb-date double-field">
                            <div class="field-con field-flex">
                                <div class="gbfdb-date-from">
                                    <label class="gbfdb-nav-title"><?php echo esc_html(__("From:","gb-forms-db")); ?></label>
                                    <input type="text" class="gbfdb-field" id="gbfdb-date-from" name="gbfdb-date-from" value="">
                                </div>
                                <div class="gbfdb-date-to">
                                    <label class="gbfdb-nav-title"><?php echo esc_html(__("To:","gb-forms-db")); ?></label>
                                    <input type="text" class="gbfdb-field" id="gbfdb-date-to" name="gbfdb-date-to" value="">
                                </div>
                                <a href="#" class=" gb_button-green gb_button dashicons dashicons-search gbfdb-search"></a>
                            </div>
                        </div>
                    </li>
                    <li class="gbfdb-leads-nav-list-item field-view-form">
                        <div class="field-wrap gbfdb-view-form">
                            <label class="gbfdb-nav-title"><?php echo esc_html(__("Form ID","gb-forms-db")); ?></label>
                            <div class="field-con">
                                <select class="gbfdb-field" id="gbfdb-view-form" name="gbfdb-view-form">
                                    <option></option>
                                </select>
                                <a href="#" class=" gb_button-green gb_button dashicons dashicons-search gbfdb-search"></a>
                            </div>
                        </div>
                    </li>
                    <li class="gbfdb-leads-nav-list-item field-text">
                        <div class="field-wrap gbfdb-text">
                            <label class="gbfdb-nav-title"><?php echo esc_html(__("Text","gb-forms-db")); ?></label>
                            <div class="field-con">
                                <input type="text" class="gbfdb-field" id="gbfdb-lead-text" name="gbfdb-lead-text" value="">
                                <a href="#" class=" gb_button-green gb_button dashicons dashicons-search gbfdb-search"></a>
                            </div>
                        </div>
                    </li>
                    <li class="gbfdb-leads-nav-list-item field-val">
                        <div class="field-wrap gbfdb-field-val double-field">
                            <div class="field-con">
                                <div class="gbfdb-field-val-title">
                                    <label class="gbfdb-nav-title"><?php echo esc_html(__("Field:","gb-forms-db")); ?></label>
                                    <input type="text" class="gbfdb-field" id="gbfdb-field-val-title" name="gbfdb-field-val-title" value="">
                                </div>
                                <div class="gbfdb-field-val-text">
                                    <label class="gbfdb-nav-title"><?php echo esc_html(__("Value:","gb-forms-db")); ?></label>
                                    <input type="text" class="gbfdb-field" id="gbfdb-field-val-text" name="gbfdb-field-val-text" value="">
                                </div>
                                <a href="#" class=" gb_button-green gb_button dashicons dashicons-search gbfdb-search"></a>
                            </div>
                        </div>
                    </li>
                    <li class="gbfdb-leads-nav-list-item field-val">
                        <div class="field-wrap gbfdb-reset">
                            <a href="#" class="gb_button-blue gb_button gbfdb-leads-reset"><?php echo __("Reset All","gb-forms-db") ?></a>
                        </div>
                    </li>
                    <?php //need to handel the CVS function ?>
                </ul>
            <?php endif;
        }

        //PUBLIC

        /*
         * call : __construct
         * do : Initiate the class
         */
        public function hooks(){

            //register custom post type
            add_action( 'init', array($this,'GBCPTRegister') );
            add_action( 'init', array($this,'GBCPTTaxonomiesRegister'), 10 );
            //add_action( 'save_post', array( $this, 'SaveMetaBox' ), 10, 2 );
            //add_action( 'save_post', array( $this, 'SaveMetaBox' ), 10, 2 );
            add_action( 'add_meta_boxes', array($this,'AddMetaBox') );
        }

        /*
         * call : hooks
         * do : Initiate the class
         */
        public function GBCPTRegister(){
            $labels = array(
                'name'               => __( $this->settings['title'], 'gb-forms-db' ),
                'singular_name'      => __( $this->settings['singular'], 'gb-forms-db' ),
                'menu_name'          => __( $this->settings['title'], 'gb-forms-db' ),
                'name_admin_bar'     => __( $this->settings['title'], 'gb-forms-db' ),
                'add_new'            => __( 'Add New', 'gb-forms-db' ).' '.$this->settings['singular'],
                'add_new_item'       => __( 'Add New', 'gb-forms-db' ).' '.$this->settings['singular'],
                'new_item'           => __( 'New ', 'gb-forms-db' ).' '.$this->settings['singular'],
                'edit_item'          => __( 'Edit', 'gb-forms-db' ).' '.$this->settings['singular'],
                'view_item'          => __( 'View', 'gb-forms-db' ).' '.$this->settings['singular'],
                'all_items'          => __( 'All', 'gb-forms-db' ).' '.$this->settings['title'],
                'search_items'       => __( 'Search', 'gb-forms-db' ).' '.$this->settings['singular'],
                'parent_item_colon'  => __( 'Parent', 'gb-forms-db' ).' '.$this->settings['singular'].':',
                'not_found'          => __( 'No lead found.', 'gb-forms-db' ),
                'not_found_in_trash' => __( 'No lead found in Trash.', 'gb-forms-db' )
            );

            $args = array(
                'labels'             => $labels,
                'description'        => $this->settings['title'].' '.__( 'is a Custom Post Type (CPT) for representing your lead.', 'gb-forms-db' ),
                'public'             => false,
                'publicly_queryable' => false,
                'menu_icon'          => 'dashicons-admin-site',
                'show_ui'            => true, //show in admin as CPT
                'show_in_menu'       => true,
                'query_var'          => true,
                'rewrite'            => array( 'slug' => __($this->settings['slug'],'gb-forms-db') ),
                'capability_type'    => 'post',
                'has_archive'        => false,
                'hierarchical'       => false,
                'menu_position'      => null,
                'show_in_rest'      => false, //Add to Rest
                'supports' => array('title','author')
            );
            register_post_type( $this->settings['id'], $args );
        }

        /*
         * call : hooks
         * do : Initiate the class
         */
        public function GBCPTTaxonomiesRegister(){
            $labels = array(
                'name'              => $this->settings['title'].' '.__( 'Categories', 'gb-forms-db' ),
                'singular_name'     => $this->settings['title'].' '.__( 'Category', 'gb-forms-db' ),
                'search_items'      => __( 'Search leads Categories', 'gb-forms-db' ),
                'all_items'         => __( 'All leads Categories', 'gb-forms-db' ),
                'parent_item'       => __( 'Parent leads Category', 'gb-forms-db' ),
                'parent_item_colon' => __( 'Parent leads Category:', 'gb-forms-db' ),
                'edit_item'         => __( 'Edit leads Category', 'gb-forms-db' ),
                'update_item'       => __( 'Update leads Category', 'gb-forms-db' ),
                'add_new_item'      => __( 'Add New leads Category', 'gb-forms-db' ),
                'new_item_name'     => __( 'New leads Category Name', 'gb-forms-db' ),
                'menu_name'         => $this->settings['title'].' '.__( 'Categories', 'gb-forms-db' ),
            );

            $args = array(
                'hierarchical'      => true,
                'labels'            => $labels,
                'show_ui'           => true,
                'show_admin_column' => true,
                'query_var'         => true,
                'show_in_rest'          => false,
            );

            register_taxonomy( $this->settings['id'].'_taxonomies', array( $this->settings['id'] ), $args );
        }


        /*
         * call : hooks //add_action( 'add_meta_boxes', array($this,'AddMetaBox') );
         * do : Add GB Calendar mata box to selected CPT's
         */
        public function AddMetaBox($setting_page){
            add_meta_box(
                'gbfdb-lead-fields',
                __( 'Lead data', 'gb-forms-db' ),
                array( $this, 'MetaBox' ),
                array($this->settings["id"]),
                'advanced',
                'high'
            );
        }

        /*
         * call : hooks //add_action( 'add_meta_boxes', array($this,'AddMetaBox') );
         * do : Add GB Calendar mata box to selected CPT's
         */
        public function get_lead_type($lead_id){
            $type = get_post_meta( $lead_id, $this->settings["option"]."_type" ,true);
            if(!$type){
                $gbfdb_lead_name = get_post_meta( $lead_id, $this->settings["option"]."_name" ,true);
                if($gbfdb_lead_name){
                    $temp_name = substr($gbfdb_lead_name,strlen('gbfdb_record_'));
                    if($temp_name){
                        $type = substr($temp_name,0,strpos($temp_name,'_'));
                    }
                }
                update_post_meta( $lead_id, $this->settings["option"]."_type" ,($type ? $type : 'undefined'));
            }
            return $type;
        }

        /*
         * call : hooks
         * do : Add mata box to places cpt
         */
        public function MetaBox($post){
            $GBFLead = new GBFLead($post->ID);
            if($GBFLead->is_loaded()):
                $gbfdb_lead_form_id = $GBFLead->getFormId();
                $gbfdb_lead_status = $GBFLead->getStatus();

                //change all new status to viewed
                if($gbfdb_lead_status == 'new'){
                    $GBFLead->setStatus('viewed');
                }
                $gbfdb_lead_name = $GBFLead->getName();
                $gbfdb_lead_meta = $GBFLead->getMeta();
                $gbfdb_lead_fields = $GBFLead->getFields();

                $type = $GBFLead->getType();

                $gbfdb_lead_meta['type'] = $type;

                $gbfdb_lead_fields["Lead ID"] = $post->ID;
                $gbfdb_lead_fields["Form ID"] = $gbfdb_lead_form_id;
                $gbfdb_lead_fields["Type"] = $type;
                $gbfdb_lead_fields["Created Date"] = $post->post_date;

                $lead_classes = array(
                    'gbfdb-lead-data-wrap',
                    'loading',
                );

                if($gbfdb_lead_status){
                    $lead_classes[] = 'status-' . $gbfdb_lead_status;
                }
            ?>
            <section id="<?php echo esc_attr($gbfdb_lead_name); ?>" data-type="<?php echo esc_attr($gbfdb_lead_fields["Type"]); ?>" class="<?php echo esc_attr(implode(" ",$lead_classes)); ?>" data-post="<?php echo $post->ID; ?>">
                <?php if($gbfdb_lead_fields): ?>
                    <div class="gbfdb-leads-scroll-wrap">
                        <div class="gbfdb-leads-scroll-con">
                            <div class="gbfdb-leads-scroll">
                                <ul class="gbfdb-fields-list">
                                    <li class="gbfdb-fields-item select">
                                        <input type="checkbox" name="gbfdb-lead-select[<?php echo intval($post->ID); ?>]" id="gbfdb-lead-select[<?php echo intval($post->ID); ?>]" value="<?php echo esc_attr($gbfdb_lead_name); ?>">
                                    </li>
                                    <?php
                                    include_once(GBFDBDIR.'core/class/GBFields.php');
                                    $gbfdb_lead_fields = apply_filters("gbfdb_lead_order",$gbfdb_lead_fields);
                                    foreach ($gbfdb_lead_fields as $key => $val):
                                        $gbfield = new GBFields($gbfdb_lead_name,array($key => $val));
                                        $class = array('gbfdb-fields-item');

                                        if($key == 'Lead ID'){
                                            $class[] = 'system';
                                            $class[] = 'small';
                                        }
                                        if($key == 'Form ID'){
                                            $class[] = 'system';
                                            $class[] = 'small';
                                            $class[] = 'gbfdb-lead-form-id';
                                        }
                                        if($key == 'Type'){
                                            $class[] = 'system';
                                            $class[] = 'small';
                                            $class[] = 'type';
                                        }
                                        if($key == 'Created Date'){
                                            //$class[] = 'system';
                                            $class[] = 'created-date';
                                        }
                                        if(substr($key, 0, 1) === '_'){
                                            $class[] = 'geeky-stuff';
                                        }
                                        ?>
                                        <li class="<?php echo esc_attr(implode(" ",$class)); ?>" title="<?php echo esc_attr(is_array($val) ? implode(', ',$val) : $val); ?>" <?php echo esc_attr(($key == 'Created Date')? "data-date=".$post->post_date:""); ?>>
                                            <?php $gbfield->get_field("field-".$gbfield->get_type()); ?>
                                        </li>
                                    <?php endforeach; ?>
                                    <?php if($gbfdb_lead_meta): ?>
                                        <?php foreach ($gbfdb_lead_meta as $key => $meta): if(is_array($meta)) continue; ?>
                                        <li class="gbfdb-fields-item <?php echo ($key == 'url' ? 'is-url' : 'geeky-stuff') ?>"  title="<?php echo esc_attr($meta); ?>">
                                            <label class="key">
                                                <?php if($key == 'url'): ?>
                                                    <?php echo __('Page','gb-forms-db'); ?>
                                                <?php else: ?>
                                                    <?php echo esc_textarea($key); ?>
                                                <?php endif; ?>
                                            </label>
                                            <label class="meta">
                                                <?php if($key == 'url'): ?>
                                                    <?php $meta = apply_filters("gbfdb_page_url",$meta); ?>
                                                <?php endif; ?>
                                                <?php echo wp_kses($meta,array('a'=> array('class' => array(),'href' => array(),'target' => array()))); ?>
                                            </label>
                                        </li>
                                        <?php endforeach; ?>
                                    <?php endif; ?>
                                    <li class="gbfdb-fields-item geeky-stuff created-date" data-date="<?php echo esc_attr($post->post_date); ?>">
                                        <label class="key"><?php echo __("Save","gb-forms-db"); ?></label>
                                        <label class="meta"><?php echo esc_html($post->post_date); ?></label>
                                    </li>
                                </ul>
                            </div>
                        </div>
                    </div>
                <?php else: ?>
                        <h5><?php _e("No field were found for this lead.","gb-forms-db"); ?></h5>
                <?php endif; ?>
            </section>
            <?php else: ?>
                <h5><?php _e("Error 1000: no meta found for this lead.","gb-forms-db"); ?></h5>
            <?php endif;

        }

        /*
         * call : *
         * do : check for new and create new leads
         */
        //todo: add cron job to check every hour for new leads
        public function checkNewData(){
            /*
            if( !(current_user_can('editor') || current_user_can('administrator')) )
                return false;
            */
            //check for delete before add new leads
            if (!empty($_POST) && isset( $_POST['gbfdb_action_sod'] ) && wp_verify_nonce( $_POST['gbfdb_action_sod'], 'gbfdb-action-nonce' )) {
                if(isset($_POST['gbfdb-action']) && !empty($_POST['gbfdb-action']) && isset($_POST['gbfdb_selected_ids']) && !empty($_POST['gbfdb_selected_ids'])){
                    if($_POST['gbfdb-action'] == 'delete'){
                        //gbfdb_selected_ids can by numbers & letters
                        $delete_ids = wp_parse_slug_list($_POST['gbfdb_selected_ids']);
                        if($delete_ids){
                            foreach ( $delete_ids as $delete_id ) {
                                if(get_post_type($delete_id) == 'gbf-leads'){
                                    wp_delete_post( $delete_id, true); // Set to False if you want to send them to Trash.
                                }
                            }
                        }
                    }
                }
            }

            global $wpdb;
            //Get all new leads
            $new_records_db = $wpdb->get_results("SELECT * FROM {$wpdb->options} WHERE option_name LIKE 'gbfdb_record_%'");
            if($new_records_db){
                foreach ($new_records_db as $index => $lead){
                    $opt_name = str_replace("gbfdb_record_","",$lead->option_name);
                    $temp = explode("_",$opt_name);
                    if($temp && is_array($temp)){
                        $type = $temp[0];
                        $datetime = new DateTime();
                        $datetime->setTimestamp($temp[1]);
                        $opt_val = maybe_unserialize($lead->option_value);

                        if(is_array($opt_val) && isset($opt_val['fields']) && isset($opt_val['meta'])){
                            $opt_field = $opt_val['fields'];
                            $opt_meta = $opt_val['meta'];
                        }else{
                            $opt_field = $opt_val;
                        }

                        $title = array(
                            'subject' => false,
                            'name' => false,
                            'date' => $datetime->format(GBFDBDATAFORMAT),
                            'email' => false,
                        );
                        foreach($opt_field as $key=>$value){
                            foreach($title as $name=>$val){
                                if(strpos($key,$name) !== false){
                                    $title[$name] = $opt_field[$key];
                                }
                            }
                        }

                        //set the lead (post) name
                        $lead_title = __("unknown","gb-forms-db");
                        if($title["subject"] != ''){
                            $lead_title = $title["subject"];
                        }else if($title["name"] != ''){
                            $lead_title = $title["name"];
                        }else if($title["email"] != ''){
                            $lead_title = $title["email"];
                        }else if($title["date"] != ''){
                            $lead_title = $title["date"];
                        }

                        $gbfdb_lead = array(
                            'post_title' => $lead_title,
                            'post_content' => "",
                            'post_type' => 'gbf-leads',
                            'post_date' => $datetime->format('Y-m-d H:i:s'),
                            'post_status' => 'publish',
                            'post_author' => get_current_user_id()
                        );

                        $newpost_id = wp_insert_post($gbfdb_lead);

                        //set the lead meta from the form
                        if($newpost_id){
                            add_post_meta($newpost_id,$this->settings["option"],$opt_field);
                            add_post_meta($newpost_id,$this->settings["option"]."_id",(isset($opt_meta['form_id']) && !empty($opt_meta['form_id']) ? $opt_meta['form_id'] : 'undefined'));
                            add_post_meta($newpost_id,$this->settings["option"]."_meta",$opt_meta);
                            add_post_meta($newpost_id,$this->settings["option"]."_name",$lead->option_name);

                            //status new,viewed,old,archive
                            add_post_meta($newpost_id,$this->settings["option"]."_status",'new');

                            //API status: new,posted,ignore
                            add_post_meta($newpost_id,$this->settings["option"]."_API_status",'new');

                            delete_option($lead->option_name);

                            if(isset($opt_meta['form_id']) && !empty($opt_meta['form_id'])){
                                do_action("after_save_lead",$newpost_id);
                            }

                        }
                    }
                }
            }
            return true;
        }

        /*
         * call : *
         * do : call to LoadAdminPage
         */
        public function set_lead_meta($lead_id,$meta,$val) {
            if(!empty($meta) && is_string($meta) && !empty($lead_id) && is_numeric($lead_id)){
                update_post_meta($lead_id,$this->settings["option"]."_".$meta,$val);
            }
        }

        /*
         * call : *
         * do : call to LoadAdminPage
         */
        public function get_lead_meta($lead_id,$meta) {
            if(!empty($meta) && is_string($meta) && !empty($lead_id) && is_numeric($lead_id)){
                return get_post_meta($lead_id,$this->settings["option"]."_".$meta);
            }
            return false;
        }

        /*
         * call : *
         * do : call to LoadAdminPage
         */
        public function get_current_screen() {
            $currentScreen = get_current_screen();
            if( $currentScreen->id === "edit-".$this->settings["id"] ) {
                $this->checkNewData();
            }
        }

        /*
         * call : *
         * do : call to LoadAdminPage
         */
        public function LeadsPage() {
            $this->checkNewData();
            $all_leads = get_posts([
                'post_type' => $this->settings['id'],
                'post_status' => 'publish',
                'numberposts' => -1
            ]);
            ?>
            <style>.gbfdb-lead-data-wrap.loading .gbfdb-leads-scroll-wrap{width: 1px;overflow: hidden;}</style>
            <header>
                <h2><?php echo esc_html(__("GB Forms DB - Leads","gb-forms-db")); ?></h2>
            </header>
            <?php if($all_leads): ?>
                <nav class="gbfdb-leads-nav">
                    <div class="gbfdb-leads-nav-list-wrap gb_style">
                        <?php $this->get_leads_nav($all_leads); ?>
                    </div>
                </nav>
            <div class="gbfdb-leads-wrap loading gb_style">
                <section class="content">
                    <ul class="gbfdb-leads-list">
                    <?php foreach($all_leads as $lead): ?>
                        <li class="lead">
                            <?php $this->MetaBox($lead); ?>
                        </li>
                    <?php endforeach; ?>
                    </ul>
                </section>
                <div class="gbfdb-loader"></div>
                <div class="gbfdb-helper">
                    <ul class="gbfdb-localisation-to-js">
                        <li data-en="Form:"><?php _e("Form:","gb-forms-db"); ?></li>
                    </ul>
                </div>
            </div>
            <?php else: ?>
                <h5><?php echo esc_html(__("No leads found.","gb-forms-db")); ?></h5>
            <?php
            endif;
        }
    }
//Return the GBFLeads class object
    function GBFLeads()
    {
        global $GBProduct;

        if( !isset($GBProduct) ){
            $GBProduct = new GBFLeads();
        }

        return $GBProduct;
    }

//End fo "do only if class NOT exists"
endif;

GBFLeads();