<?php
// no access directly
if ( ! defined( 'ABSPATH' ) ) {
    die( '&ldquo;the door is shut it was made by those who are dead&rdquo;' );
}

if( !class_exists('GBFields') ):
    class GBFields{
        private $type;
        private $value;
        private $name;
        private $title;
        private $id;
        private $status;
        function __construct($opt_name,$data = array()){
            $this->status = false;
            $this->init($opt_name,$data);
            return $this->status;
        }

        //PRIVATE

        /*
         * call : __construct
         * do : Initiate the class
         */
        private function init($opt_name,$data){
            if(!($opt_name && $this->set_id($opt_name)) && !is_array($data) && !isset(array_keys($data)[0])){
                return false;
            }

            if (!empty(array_values($data)[0]) && filter_var(array_values($data)[0], FILTER_VALIDATE_EMAIL)){
                $this->type = "email";
            }

            if(!empty(array_keys($data)[0]) && substr_count("tel",array_keys($data)[0])){
                $this->type = "phone";
            }

            if(!empty(array_keys($data)[0]) && substr_count("mob",array_keys($data)[0])){
                $this->type = "phone";
            }

            if(!empty(array_keys($data)[0]) && substr_count("name",array_keys($data)[0])){
                $this->type = "text";
            }

            if(!empty(array_values($data)[0]) && is_numeric(array_values($data)[0])){
                $this->type = "number";
            }

            if($this->type == ""){
                $this->type = "text";
            }

            $this->name = array_keys($data)[0];
            $this->id = $this->name . "_" . $this->id;

            $this->value = $data[$this->name];

            $this->status = true;
        }

        /*
         * call : *
         * do : set the name of the field
         */
        private function set_id($val = ""){
            if(is_string($val) && strpos($val,'gbfdb_record_') == 0){
                $op_name = substr($val,strlen('gbfdb_record_'));
                if(strpos($op_name,'_') > 0){
                    $this->id = esc_attr($op_name);
                    return true;
                }
            }
            return false;
        }

        //PUBLIC

        /*
         * call : *
         * do : return the title of the field
         */
        public function get_id(){
            return $this->id;
        }
        
        /*
         * call : *
         * do : return the value of the field
         */
        public function get_value(){
            return $this->value;
        }

        /*
         * call : *
         * do : set the value of the field
         */
        public function set_value($val){
            $this->value = $val;
        }
        
        /*
         * call : *
         * do : return the name of the field
         */
        public function get_name(){
            return $this->name;
        }

        /*
         * call : *
         * do : set the name of the field
         */
        public function set_name($val){
            $this->name = $val;
        }

        /*
         * call : *
         * do : return the title of the field
         */
        public function get_title(){
            return $this->title;
        }

        /*
         * call : *
         * do : set the title of the field
         */
        public function set_title($val){
            $this->title = $val;
        }

        /*
         * call : *
         * do : output the field
         */
        public function get_field($classes=""){
            $field = array(
                'id' => $this->id,
                'name' => $this->name,
                'type' => $this->type,
                'value' => $this->value,
                'classes' => $classes,
            );
            $field = apply_filters("gbfdb_field_output_data",$field,$this->id);
            if($field && is_array($field) && (isset($field['type']) && isset($field['name']) && isset($field['id']) && isset($field['value']))):
                do_action("before_gbfdb_field_output",$field);
                ?>
                <div class="gbfdb-field-wrap">
                    <label class="field-title" for="<?php echo esc_attr($field['id']); ?>"><?php echo esc_html($field['name']); ?></label>
                    <div class="gbfdb-field-con">
                        <label class="field-label" for="<?php echo esc_attr($field['id']); ?>"><?php echo esc_attr(is_array($field['value']) ? implode(', ',$field['value']) : $field['value']); ?></label>
                        <input type="<?php echo esc_attr($field['type']); ?>" name="<?php echo esc_attr($field['name']); ?>" id="<?php echo esc_attr($field['id']); ?>" value="<?php echo esc_attr(is_array($field['value']) ? implode(', ',$field['value']) : $field['value']); ?>" class="<?php echo esc_attr($field['classes']); ?> gbfdb-field">
                    </div>
                </div>
            <?php do_action("after_gbfdb_field_output",$field); else: ?>
                <label class="gbfdb-field-error"><?php echo __("There was something wrong with this field.","gb-forms-db"); ?></label>
            <?php
            endif;
        }

        /*
         * call : *
         * do : save the field
         */
        public function set_field($val){

        }

        /*
         * call : *
         * do : return the field type
         */
        public function get_type(){
            return $this->type;
        }
    }
//End fo "do only if class NOT exists"
endif;