<?php
//blocking direct access the file
defined( 'ABSPATH' ) or die( 'No script kiddies please!' );

if( !class_exists('gb-forms-db') ):
    class gbfdb{
        private $settings;
        function __construct(){
            $this->settings = $this->GetGBSettings();

            $this->hooks();

            $this->init();

        }

        //PRIVATE

        /*
         * call : * in class
         * do : return array of settings
         */
        private function GetGBSettings(){
            $out = array(
                'admin_page' => array(
                    'page_title' => __( 'GB Forms DB', 'gb-forms-db' ),
                    'menu_title' => __( 'GB Forms DB', 'gb-forms-db' ),
                    'capability' => 'manage_options',
                    'menu_slug' => 'gbformsdbadmin',
                    'function' => array($this,'AdminPage'),
                    'icon_url' => GBFDBURL.'/images/gb_admin_menu.png'
                )
            );
            return $out;
        }

        /*
         * call : __construct
         * do : Initiate the class
         */
        private function init(){

        }


        //PUBLIC

        /*
         * activate : admin_menu
         * do : echo the plugin admin page
         */
        public function AdminPage(){
            global $gbfdbadmin;
            $gbfdbadmin->AdminPage();
        }

        /*
         * activate : admin_menu
         * do : echo the plugin admin page
         */
        public function LeadsPage(){
            if(function_exists("GBFLeads")){
                global $GBFLeads;
                $GBFLeads = GBFLeads();
                $GBFLeads->LeadsPage();
            }else{
                $this->NeedToEnabel();
            }
        }

        /*
         * call : hooks
         * hook: admin_menu
         * do : register the admin plugin page
         */
        public function AddAdminPage(){
            if(isset($this->settings['admin_page']) && is_array($this->settings['admin_page']) && !empty($this->settings['admin_page']))
            extract($this->settings['admin_page'],EXTR_PREFIX_SAME,"wddx");
            add_menu_page($page_title,$menu_title,$capability,$menu_slug,$function,$icon_url);

            add_submenu_page( $menu_slug, __("All Leads","gb-forms-db"), __("All Leads","gb-forms-db"),
                'manage_options', $menu_slug.'_leads',array($this,"LeadsPage"));
        }

        /*
         * call : __construct
         * do : add all the hooks and filter
         */
        public function NeedToEnabel(){
            ?>
            <h2>
                <?php
                echo sprintf(
                    __( 'Please visit the GB Forms DB settings %1$spage%2$s and save your settings to enable the plugin to work.', 'gb-forms-db' ),
                    '<a href="' . esc_url( admin_url("admin.php?page=gbformsdbadmin") ) . '">',
                    '</a>'
                );
                ?>
            </h2>
            <?php
        }

        /*
         * call : __construct
         * do : add all the hooks and filter
         */
        public function hooks(){
            add_action( 'admin_menu', array($this,'AddAdminPage') );
        }
    }
//Return the gbfdb class object
    function gbfdb(){
        global $gbfdb;

        if( !isset($gbfdb) ){
            $gbfdb = new gbfdb();
        }

        return $gbfdb;
    }

//End fo "do only if class NOT exists"
endif;

gbfdb();