<?php
//blocking direct access the file
defined( 'ABSPATH' ) or die( 'No script kiddies please!' );
include_once('class/class-start.php');

if(get_option('gbfdb_enabled')){
    include_once (GBFDBDIR.'core/class/GBFLeads.php');
    include_once (GBFDBDIR.'core/class/GBFLead.php');
}
function gbcf_includes(){
    load_plugin_textdomain( 'gb-forms-db', false, 'gb-forms-db/languages' );

    if(is_admin()){
        include_once (GBFDBDIR.'core/class/GBFDBAdmin.php');
        include_once (GBFDBDIR.'core/gbfdb_notice.php');
    }else{
        include_once (GBFDBDIR.'core/class/GBFDBFront.php');
    }

    //schedule new cron job
    if (!wp_next_scheduled('gbfdb_check_new_leads')) {
        wp_schedule_event( time(),'hourly','gbfdb_check_new_leads');
    }
}
add_action('init','gbcf_includes');

//add_action( 'init', 'gbfdb_hourly_check_new_leads', 10);
add_action( 'gbfdb_check_new_leads', 'gbfdb_hourly_check_new_leads', 10);
function gbfdb_hourly_check_new_leads() {
    $GBFLeads = new GBFLeads();
    $GBFLeads->checkNewData();
}

function gbfdb_find_forms_plugins(){
    $supported_plugins = array(
        'forms' => array(
            'slug' => 'all-forms',
            'short' => 'forms',
            'name' => 'All Forms',
            'active' => 'submit',
            'field-hook' => false,
            'description' => __("By enabling the \"All Forms\" option, all of your forms submissions will be saved in the \"All Leads\" page\nNOTICE: Custom made forms using Ajax technology will not be saved, please contact your developer to support Ajax based forms","gb-forms-db"),
            'html_icon' => '',
            'validation_hook' => ''
        ),
        'contact-form-7/wp-contact-form-7.php' => array(
            'slug' => 'contact-form-7',
            'short' => 'cf7',
            'name' => 'Contact form 7',
            'active' => 'contact-form-7/wp-contact-form-7.php',
            'field-hook' => false,
            'description' => '',
            'html_icon' => '',
            'validation_hook' => ''
        ),
        'elementor/elementor.php' => array(
            'slug' => 'elementor',
            'short' => 'elementor',
            'name' => 'Elementor Forms',
            'active' => 'elementor/elementor.php',
            'field-hook' => false,
            'description' => '',
            'html_icon' => '<div class="elementor-message-icon"><div class="e-logo-wrapper"><i class="eicon-elementor" aria-hidden="true"></i></div></div>',
            'validation_hook' => ''
        ),
        'pojo-forms/pojo-forms.php' => array(
            'slug' => 'pojo-forms',
            'short' => 'pojo',
            'name' => 'Pojo Forms',
            'active' => 'pojo-forms/pojo-forms.php',
            'field-hook' => false,
            'description' => '',
            'html_icon' => '',
            'validation_hook' => ''
        ),
        'gravityforms/gravityforms.php' => array(
            'slug' => 'gravityforms',
            'short' => 'gravity',
            'name' => 'Gravity Forms',
            'active' => 'gravityforms/gravityforms.php',
            'field-hook' => false,
            'description' => '',
            'html_icon' => '',
            'validation_hook' => ''
        ),
        'ninja-forms/ninja-forms.php' => array(
            'slug' => 'ninja-forms',
            'short' => 'ninja',
            'name' => 'Ninja Forms',
            'active' => 'ninja-forms/ninja-forms.php',
            'field-hook' => false,
            'description' => '',
            'html_icon' => '',
            'validation_hook' => ''
        ),
        'form' => array(
            'slug' => 'form',
            'short' => 'form',
            'name' => 'Form id',
            'active' => 'submit',
            'field-hook' => 'gbfdb_form_field',
            'description' => sprintf(
                __( 'Enter the <a target="_blank" href=%s>selector</a> indicating your form', 'gb-forms-db' ),
                esc_url( "https://www.w3schools.com/cssref/css_selectors.asp")),
            'html_icon' => '',
            'validation_hook' => 'validate_form_id'
        )
    );
    $active_plugins = get_option('active_plugins');
    update_option('gbfdb_supported_plugins',$supported_plugins);
    if($active_plugins){
        $first_activate_plugins = array();
        foreach ($active_plugins as $active_plugin){
            if(array_key_exists($active_plugin,$supported_plugins)){
                $first_activate_plugins[] = $supported_plugins[$active_plugin]['slug'];
            }
        }
        if(!empty($first_activate_plugins)){
            update_option('gbfdb_first_activate_plugins',$first_activate_plugins);
        }
    }

    $recurrence = "";
    //schedule new cron job
    if (!wp_next_scheduled('gbfdb_check_new_leads')) {
        wp_schedule_event( time(),'hourly','gbfdb_check_new_leads');
    }
}

add_filter( 'cron_schedules', 'gbfdb_cron_schedules' );
function gbfdb_cron_schedules( $schedules ) {
    // Adds once weekly to the existing schedules.
    $schedules['Thirty-minutes'] = array(
        'interval' => (30*60),
        'display' => __( 'Thirty minutes','gb-forms-db' )
    );
    return $schedules;
}


//collect elementor leads
add_action( 'elementor_pro/forms/new_record', 'gbfdb_elementor_leads', 10, 2 );
function gbfdb_elementor_leads( $record, $handler ) {
    $raw_fields = $record->get( 'fields' );
    $fields = [];
    foreach ( $raw_fields as $id => $field ) {
        $fields[ $id ] = $field['value'];
    }
    $time = strtotime("now");
    $meta = $record->get_formatted_data(true);

    if(!isset($meta['type'])){
        $meta['type'] = 'elementor';
    }

    $meta['form_id'] = sanitize_title(isset($_POST['form_id']) ? $_POST['form_id'] : 'undefined');
    if(!isset($meta['url'])){
        $actual_link = (isset($_SERVER["HTTP_REFERER"]) ? sanitize_url($_SERVER["HTTP_REFERER"]) : "");
        $meta['url'] = (!empty($actual_link) ? $actual_link : 'undefined');
    }

    $data = array(
        'fields' => $fields,
        'meta' => $meta
    );

    //use for auto send
    do_action('gbfdb_after_save_'.$meta['form_id'],$data);

    add_option('gbfdb_record_elementor_'.$time,$data);
}

//collect CF7 leads
add_action( 'wpcf7_mail_sent', 'gbfdb_cf7_leads' );
function gbfdb_cf7_leads( $contact_form ) {
    $GBFDBFront = GBFDBFront();
    if($GBFDBFront->check_form_action('action','wpcf7_mail_sent')){
        $submission = WPCF7_Submission::get_instance();
        $fields = $submission->get_posted_data();
        $time = strtotime("now");
        $form_meta = array(
            'form_id' => sanitize_title(isset($_POST['_wpcf7']) ? $_POST['_wpcf7'] : 'undefined'),
            'type' => 'cf7',
            'remote_ip' => $submission->get_meta('remote_ip'),
            'user_agent' => $submission->get_meta('user_agent'),
            'url' => $submission->get_meta('url'),
            'timestamp' => $submission->get_meta('timestamp'),
            'unit_tag' => $submission->get_meta('unit_tag')
        );

        $data = array(
            'fields' => $fields,
            'meta' => $form_meta
        );

        //use for auto send
        do_action('gbfdb_after_save_'.$form_meta['form_id'],$data);

        add_option('gbfdb_record_wpcf7_'.$time,$data);
    }
}

//collect pojo forms leads
add_action("pojo_forms_mail_sent","gbfdb_pojo_forms_leads", 25, 3);
function gbfdb_pojo_forms_leads($form_id, $field_values, $files = array()){
    $supported_plugins = get_option("gbfdp_supported_plugins");
    if(in_array('pojo',$supported_plugins)) {
        $time = strtotime("now");
        $form_meta = array();
        $fields = array();
        $form_meta['created'] = $time;

        if(is_array($field_values)){
            foreach ($field_values as $index => $items){
                $fields[$items['title']] = (!empty($items['value']) ? $items['value'] : '0');
            }
        }

        $form_meta['form_id'] = sanitize_title(!empty($form_id) ? $form_id : 'undefined');
        $actual_link = (isset($_SERVER["HTTP_REFERER"]) ? sanitize_url($_SERVER["HTTP_REFERER"]) : "");
        $form_meta['url'] = (!empty($actual_link) ? $actual_link : 'undefined');


        $all_data = array(
            'fields' => $fields,
            'meta' => $form_meta
        );

        //use for auto send
        do_action('gbfdb_after_save_'.$form_meta['form_id'],$all_data);

        add_option('gbfdb_record_pojo_' . $time, $all_data);
    }
}

//collect ninja forms leads
add_action("ninja_forms_after_submission","gbfdb_ninja_forms_leads", 25, 1);
function gbfdb_ninja_forms_leads($form_data){
    if($form_data && isset($form_data['form_id'])){

        $supported_plugins = get_option("gbfdp_supported_plugins");
        if(in_array('ninja',$supported_plugins)){


            $time = strtotime("now");
            $fields = array();
            $form_meta = array();

            //meta

            if(isset($form_data['settings'])){
                $form_meta['created'] = (isset($form_data['settings']['created_at']) ? $form_data['settings']['created_at'] : $time);
            }


            //fields

            if(isset($form_data['fields'])){
                foreach ($form_data['fields'] as $form_fields){
                    if((isset($form_fields['label']) && isset($form_fields['value'])) && (isset($form_fields['type']) && $form_fields['type'] != "submit")){
                        $fields[$form_fields['label']] = $form_fields['value'];
                    }
                }
            }

            $actual_link = (isset($_SERVER["HTTP_REFERER"]) ? sanitize_url($_SERVER["HTTP_REFERER"]) : "");

            $form_meta['form_id'] = sanitize_title($form_data['form_id'] ? $form_data['form_id'] : 'undefined');
            $form_meta['url'] = ($actual_link ? $actual_link : 'undefined');


            $all_data = array(
                'fields' => $fields,
                'meta' => $form_meta
            );

            //use for auto send
            do_action('gbfdb_after_save_'.$form_meta['form_id'],$all_data);

            add_option('gbfdb_record_ninja_'.$time,$all_data);
        }
    }
    return $form_data;
}


//gravity forms
add_action( 'gform_after_submission', 'gbfdb_gform_submission', 10, 2 );
function gbfdb_gform_submission( $entry, $form ) {
    $save = false;
    $supported_plugins = get_option("gbfdp_supported_plugins");
    if(in_array('gravity',$supported_plugins)) {
        $save = true;
    }
    if(!$save && in_array('all-forms',$supported_plugins)) {
        $save = true;
    }

    if($save){
        $post = get_post( $entry['post_id'] );

        $time = strtotime("now");

        $form_meta = array();
        $fields = array();
        $form_meta['created'] = $entry['date_created'];
        $form_meta['ip'] = $entry['ip'];
        $form_meta['user_agent'] = $entry['user_agent'];
        $form_meta['url'] = get_permalink($post);

        if(is_array($form) && isset($form['fields'])){
            foreach ($form['fields'] as $index => $item){
                $fields[$item['label']] = $entry[$item['id']];
            }
        }

        $form_meta['form_id'] = sanitize_title($form['id'] ? $form['id'] : 'undefined');

        $all_data = array(
            'fields' => $fields,
            'meta' => $form_meta
        );

        //use for auto send
        do_action('gbfdb_after_save_'.$form_meta['form_id'],$all_data);

        add_option('gbfdb_record_gravity_' . $time, $all_data);
    }
}

function gbfdb_talk_to_front(){

    check_ajax_referer( 'gbfdb_sod', 'sod' );

    if(isset($_POST) && isset($_POST['data']) && $_POST['data'] != "" && isset($_POST['function']) && $_POST['function'] != '' && function_exists($_POST['function'])){
        //#q#
        $temp = str_replace('#q#','"',$_POST['data']);
        if(!gbfdb_is_json($temp)){
            echo '-1';
            wp_die();
        }
        $data = json_decode($temp,true);
        foreach ($data as $key => $val){
            switch ($key){
                case 'gbfdb_meta_action':
                case 'gbfdb_meta_datetime':
                case 'gbfdb_meta_userAgent':
                    $data[$key] = sanitize_text_field($val);
                    break;
                case 'gbfdb_meta_url':
                    $data[$key] = sanitize_url($val);
                    break;
                default:
                    if(strpos($key, 'email') !== false){
                        $data[$key] = sanitize_email($val);
                    }else if(strpos($key, 'message') !== false){
                        $data[$key] = sanitize_textarea_field($val);
                    }else{
                        $data[$key] = sanitize_text_field($val);
                    }
            }
        }
        $out = "!@#";
        $out .= call_user_func($_POST['function'],$data);
        $out .= "#@!";
    }else{
        $out = "no-data";
    }
    echo esc_html($out);
    wp_die();
}
add_action('wp_ajax_gbfdb_talk_to_front', 'gbfdb_talk_to_front');
add_action('wp_ajax_nopriv_gbfdb_talk_to_front', 'gbfdb_talk_to_front');

function gbfdb_all_forms_save($data){
    if($data && is_array($data)){
        $supported_plugins = get_option("gbfdp_supported_plugins");
        if($supported_plugins){
            if(in_array('elementor',$supported_plugins) && (array_key_exists('form_id',$data) && array_key_exists('post_id',$data))){
                return true;
            }
            foreach($data as $key=>$value){
                //return true to all hooks plugins
                if(in_array('cf7',$supported_plugins) && stristr($key,'wpcf7')!==FALSE){
                    return true;
                }
            }
        }

        $form_meta = array();
        $fields = array();
        foreach($data as $key_name => $value){
            if(strpos($key_name,'gbfdb_meta_') !== false){
                $form_meta[substr($key_name,strlen('gbfdb_meta_'))] = $value;
            }else{
                if(strpos($key_name,"wpcf7") >-1){
                    if($key_name == '_wpcf7'){
                        $form_meta['form_id'] = $value;
                    }
                    $form_meta[$key_name] = $value;
                    $form_meta['type'] = 'cf7';
                }else{
                    $fields[$key_name] = $value;
                }
            }
        }
        if(!isset($form_meta['type'])){
            $form_meta['type'] = 'forms';
        }

        if(!isset($form_meta['url'])){
            $actual_link = (isset($_SERVER["HTTP_REFERER"]) ? sanitize_url($_SERVER["HTTP_REFERER"]) : "");
            $form_meta['url'] = ($actual_link ? $actual_link : 'undefined');
        }


        $form_meta['form_id'] = sanitize_title(isset($_POST['form_id']) ? $_POST['form_id'] : 'undefined');

        $time = strtotime("now");
        $all_data = array(
            'fields' => $fields,
            'meta' => $form_meta
        );

        //use for auto send
        do_action('gbfdb_after_save_'.$form_meta['form_id'],$all_data);

        add_option('gbfdb_record_forms_'.$time,$all_data);
    }

    return true;
}

//add input text to GB Forms DB settings page for "Form id" selector
add_action("gbfdb_form_field",function($data = array()){
    $val = "";
    $disabled = true;
    if(isset($data['supported_plugins']) && is_array($data['supported_plugins']) && in_array("form",$data['supported_plugins'])){
        $disabled = false;
    }

    if(isset($data['gbfdb-form-selector'])){
        $val = $data['gbfdb-form-selector'];
    }
    ?>
    <input type="text" class="gbfdb-form-selector" placeholder="<?php echo esc_attr(__("insert your form selector","gb-forms-db")); ?>" name="gbfdb-form-selector" id="gbfdb-form-selector" <?php echo ($disabled ? 'disabled' : ''); ?> value="<?php echo esc_attr($val); ?>">
    <?php
});

add_filter('gbfdb_page_url',function($url){
    if(!empty($url)){
        $post_id = url_to_postid($url);
        if($post_id){
            $out = '';
            $out .= '<a class="gbfdb-lead-url" target="_blank" href="'.esc_url(get_permalink($post_id)).'">'.get_the_title($post_id).'</a>';
            return $out;
        }else if($category_id = get_category_by_path(esc_url($url),false)){
            $category = get_term( $category_id );
            if($category){
                $out = '';
                $out .= '<a class="gbfdb-lead-url" target="_blank" href="'.esc_url($url).'">'.$category->name.'</a>';
                return $out;
            }
        }else{
            $out = '';
            $out .= '<a class="gbfdb-lead-url" target="_blank" href="'.esc_url($url).'">'.__("Unknown","gb-forms-db").'</a>';
            return $out;
        }
    }
    return __("Unknown","gb-forms-db");
},10,1);

//validate gbfdb admin data before save.
//return true if all validate or notice message for false
add_filter("validate_form_id",function($message,$data){
    //Do your code with $data and return the data
    if(is_array($data) && isset($data['supported_plugins']) && is_array($data['supported_plugins']) && in_array("form",$data['supported_plugins'])){
        if(!isset($data['gbfdb-form-selector']) || empty($data['gbfdb-form-selector'])){
            $message = __('Please enter form selector','gb-forms-db');
            return $message;
        }
    }
    return true;
},10,2);

add_filter("gbfdb_field_output_data",function($data,$id){
    //Do your code with $data and return the data

    return $data;
},10,2);

function gbfdb_is_json($string) {
    if(is_string($string)){
        json_decode($string,true);
        return (json_last_error() == JSON_ERROR_NONE);
    }
    return false;
}

//sort lead fields order
add_filter("gbfdb_lead_order","gbfdb_example_lead_order",5,1);
function gbfdb_example_lead_order($lead){
    $new_order = array();
    if(isset($lead['Type']) && $lead['Type'] == 'wpcf7'){
        uksort($lead, 'gbfdb_lead_order_sort_wpcf7');
    }
    if(empty($new_order)){
        $new_order = $lead;
    }

    return $new_order;
}
function gbfdb_lead_order_sort_wpcf7($a,$b){
    if(substr($a, 0, 1) === '_' && substr($b, 0, 1) === '_'){
        return 0;
    }else if(substr($a, 0, 1) === '_'){
        return 1;
    }else if(substr($b, 0, 1) === '_'){
        return -1;
    }else{
        return 0;
    }
}

/************************************/
//DEBUG
/************************************/
if ( ! function_exists( 'gb_print_log' ) ):
    function gb_print_log($array, $var_dump = false, $place = ''){
        //die(print_r(debug_backtrace(),true));
        if($place == ''){
            $place_array = debug_backtrace();
            $place = $place_array[0]['file'].' - Line:'.$place_array[0]['line'];
        }

        if(is_bool($array) || !$array || empty($array)){
            $var_dump = true;
        }
        $file = fopen(GBFDBDIR."debug.txt","a");
        $date = new DateTime('NOW');
        fwrite($file,"\n----------\n".print_r($date->format('d/m/Y - H:i:s')." --- \n".$place."\n".print_r($array,true),true));
        fclose($file);
    }
endif;