<?php
//blocking direct access the file
defined( 'ABSPATH' ) or die( 'No script kiddies please!' );
class gbfdb_notice{
    private $settings;
    private $notices;
    function __construct(){
        $this->settings = $this->GetGBSettings();
        $this->notices = array();

        add_action('admin_enqueue_scripts', array($this,"enqueue_scripts"));

        $this->init();

    }

    //PRIVATE

    /*
     * call : * in class
     * do : return array of settings
     */
    private function GetGBSettings(){
        $out = array();
        return $out;
    }

    /*
     * call : __construct
     * do : Initiate the class
     */
    private function init(){

    }


    //PUBLIC

    /*
     * call : __construct
     * do : add all the hooks and filter
     */
    public function enqueue_scripts(){
        wp_enqueue_script( 'gbfdb-notice-script', GBFDBURL.'/core/js/gbfdb_notice.js','',true);
        wp_localize_script( 'gbfdb-notice-script', 'gbfdb_notice', array(
            'ajaxurl' => admin_url( 'admin-ajax.php' ),
            'notice_sod' => wp_create_nonce( 'notice_sod' )
        ));
    }

    /*
     * call : *
     * do : add notice to display
     */
    public function add_notice($for = '', $message = ''){
        if(is_string($for) && is_string($message) && !empty($message) && !empty($for))
        $this->notices[] = array(
            'for' => $for,
            'message' => $message
        );
    }

    /*
     * call : *
     * do : add notice to display
     */
    public function get_notice($for = ''){
        if(is_string($for) && !empty($for)){
            $temp_notice = array();
            foreach ($this->notices as $notice){
                if($for == $notice['for']){
                    $temp_notice[] = $notice['message'];
                }
            }
            if(!empty($temp_notice)){
                return $temp_notice;
            }
        }
        return false;
    }

    /*
     * call : *
     * do : add notice to display
     */
    public function get_all_notices(){
        return $this->notices;
    }

    /*
     * call : *
     * do : check if has notices
     */
    public function has_notice(){
        return count($this->notices);
    }

    /*
     * call : *
     * do : output the notices html
     */
    public function output_notices(){
        ?>
        <aside class="gbfdb_notice">
            <label class="notices-title"><?php esc_html(__("There were some problems with the form:","gb-forms-db")) ?></label>
            <ol>
                <?php foreach ($this->notices as $notice): ?>
                    <li><?php echo esc_html($notice['for']); ?>: <?php echo esc_textarea($notice['message']); ?></li>
                <?php endforeach; ?>
            </ol>
        </aside>
        <?php
    }
}