jQuery(document).ready(function() {
    gbfdb_init();

    jQuery('.field-wrap a.gbfdb-leads-reset').on("click",function(e){e.preventDefault(); gbfdb_filter_reset();});

    //on filter search
    jQuery('.field-wrap a.gbfdb-search').on("click",function(e){e.preventDefault(); gbfdb_filter_text(jQuery(this));});

    jQuery('.field-wrap #gbfdb-view-period').on("change",function(){
        if(jQuery(this).val() == 'period'){
            jQuery(this).closest('.field-con').find('a.gbfdb-search').hide();
            jQuery(document).find('.gbfdb-leads-nav-list-item.field-date').addClass('show');
        }else{
            jQuery(this).closest('.field-con').find('a.gbfdb-search').show();
            jQuery(document).find('.gbfdb-leads-nav-list-item.field-date').removeClass('show');
            gbfdb_filter_text(jQuery(this).parent().find('a.gbfdb-search'));
        }
    });

    jQuery('#gb-menu-toggle').on("click",function(e){e.preventDefault();jQuery(this).closest('.gbfdb-leads-wrap').toggleClass('menu-open');});

    jQuery('a.gbfdb-leads-cvs').on("click",function(e){e.preventDefault();gbfdb_save_svg();});

    jQuery('#gbfdb-admin-page legend a.gbfdb-legend').on("click",function(e){e.preventDefault();legend_link(jQuery(this));});

    jQuery(document).on("click",".advanced-option-toggle",function(e){e.preventDefault();jQuery(this).closest(".advanced-option").toggleClass('open');});

    jQuery('.gbfdb-checkbox').find('input[type="checkbox"]').on('change',function(){gbfdb_checkbox_change(jQuery(this))});

    //open the lead view
    jQuery('section.gbfdb-lead-data-wrap').on("click",function(e){
        if(jQuery(e.target).is('.gbfdb-lead-url')){

        }else if(!jQuery(e.target).is('input[type="checkbox"]')){
            e.stopPropagation();
            gbfdb_open_lead_view(jQuery(this));
        }else if(jQuery('#gbfdb_selected_ids').length){
            var new_id = jQuery(e.target).closest('.gbfdb-lead-data-wrap[data-post]').attr('data-post');
            if(jQuery('#gbfdb_selected_ids').val()){
                var ids = jQuery('#gbfdb_selected_ids').val();
                ids = ids.split(',');
                ids.push(new_id);
                jQuery('#gbfdb_selected_ids').val(ids.join(','));
            }else{
                jQuery('#gbfdb_selected_ids').val(new_id);
            }
        }
    });

    jQuery('.gbfdb-checkbox-array input[type="checkbox"]').on('change',function(){gbfdb_checkbox_array_change(jQuery(this))});

    jQuery('#gbfdb_enable').on("change",function(e){
        jQuery(this).closest(".fields-section").find('.gbfdb-fields-wrap').toggleClass("gbfdb-enable");
        jQuery(this).closest(".fields-section").find('.gbfdb-fields-wrap').toggleClass("gbfdb-disable");
    });

    jQuery(document).on("click",".gbfdb-field-wrap .gbfdb-field-button",function(e){
        e.preventDefault();
        gbfdb_field_button(jQuery(this));
    });

});
document.addEventListener("DOMContentLoaded", function(event) {
    var LeadsViewerArray = document.querySelectorAll('.gbfdb-lead-data-wrap');
    if(LeadsViewerArray){
        LoadGBFDBLeads(LeadsViewerArray);
    }
});

function gb_is_url(str)
{
    regexp =  /^(?:(?:https?|ftp):\/\/)?(?:(?!(?:10|127)(?:\.\d{1,3}){3})(?!(?:169\.254|192\.168)(?:\.\d{1,3}){2})(?!172\.(?:1[6-9]|2\d|3[0-1])(?:\.\d{1,3}){2})(?:[1-9]\d?|1\d\d|2[01]\d|22[0-3])(?:\.(?:1?\d{1,2}|2[0-4]\d|25[0-5])){2}(?:\.(?:[1-9]\d?|1\d\d|2[0-4]\d|25[0-4]))|(?:(?:[a-z\u00a1-\uffff0-9]-*)*[a-z\u00a1-\uffff0-9]+)(?:\.(?:[a-z\u00a1-\uffff0-9]-*)*[a-z\u00a1-\uffff0-9]+)*(?:\.(?:[a-z\u00a1-\uffff]{2,})))(?::\d{2,5})?(?:\/\S*)?$/;
    if (regexp.test(str))
    {
        return true;
    }
    else
    {
        return false;
    }
}

function legend_link(legend_link){
    if(!legend_link.is('.selected')){
        var fieldset = legend_link.closest('fieldset');
        fieldset.find('.selected').removeClass('selected');
        legend_link.addClass('selected');
        fieldset.find('section[data-item="'+legend_link.attr("data-for")+'"]').addClass('selected');
    }
}

//set the lead popup view
function gbfdb_open_lead_view(lead_section){
    if(!jQuery("body").is('.gbweb-shadowbox-open') && lead_section.length){
        var content = jQuery('<div class="popup-lead-wrap"></div>');
        var lead_data = lead_section.find('ul.gbfdb-fields-list').clone();
        jQuery(content).append(lead_data);

        //var api_wrap = jQuery('<div class="gbfdb-api-wrap"></div>');

        //set the form type for api
        //api_wrap.attr('data-type',lead_section.attr('data-type'));

        //jQuery(content).append(api_wrap);

        //gbfdb_get_api_form(jQuery(content).find('.gbfdb-api-wrap'),lead_data,lead_section.attr('data-post'));


        //jQuery(content).find('#gbfdb_api_post_body').text();

        jQuery('body').shadowbox(content);
    }

}

function gbfdb_checkbox_change(checkbox) {
    if(checkbox.is('#show_system_fields')){
        $action = checkbox.prop('checked');
        jQuery('.gbfdb-fields-item.system').each(function(){
            if($action){
                jQuery(this).removeClass('hide');
            }else{
                jQuery(this).addClass('hide');
            }
        });
    }else if(checkbox.is('#gbfdb-select-all')){
        if(jQuery('.lead:not(".hide")').length){
            var ids = [];
            jQuery('.lead:not(".hide")').each(function(){
                if(checkbox.prop("checked")){
                    jQuery(this).find('.gbfdb-fields-item.select input[type="checkbox"]').prop('checked',true);
                    ids.push(jQuery(this).find('.gbfdb-lead-data-wrap[data-post]').attr('data-post'));
                }else{
                    jQuery(this).find('.gbfdb-fields-item.select input[type="checkbox"]').prop('checked',false);
                }
            });
            if(checkbox.prop("checked")){
                if(ids.length){
                    jQuery('#gbfdb_selected_ids').attr('value',ids.join(","));
                }
            }else{
                jQuery('#gbfdb_selected_ids').attr('value','');
            }
        }
    }
}

function gbfdb_checkbox_array_change(checkbox){
    if(!checkbox.prop('checked')){
        checkbox.removeAttr('checked');
    }

    if(checkbox.is('#supported_plugins_form-id')){
        if(checkbox.prop('checked')){
            checkbox.closest(".gbfdb-checkbox-array").find("#gbfdb-form-selector").prop('disabled',false);
        }else{
            checkbox.closest(".gbfdb-checkbox-array").find("#gbfdb-form-selector").prop('disabled',true);
        }
    }
}
function gbfdb_get_api_form(item,lead_data,lead_id){
    var data = {
        action: 'gbfdb_api_form',
        sod : gbfdb_api.api_sod,
        data : lead_id
    };

    var gbfdb_form_data = new FormData();

    for ( var key in data ) {
        gbfdb_form_data.append(key, data[key]);
    }

    xhttp = new XMLHttpRequest();
    xhttp.open("POST", gbfdb_api.ajaxurl, true);

    xhttp.onreadystatechange = function() {
        if (this.readyState == 4 && this.status == 200 && this.responseText.indexOf('!@#') == 0 && this.responseText.indexOf('#@!') > 0) {
            var response = this.responseText.replace('!@#', '');
            response = response.replace('#@!', '');
            if(response != 1){
                var api = jQuery(response);
                item.append(gbfdb_api_form_set_data(api,lead_data));
                if(item.find('#gbfdb_api_post_link').length && item.find('#gbfdb_api_post_link').val() != ''){
                    item.find('#save_form_ip').prop('disabled',false);
                }
                item.attr("lead-id",lead_id);
            }
        }
    };
    xhttp.send(gbfdb_form_data);
}
function gbweb_show_responce(data_response) {
    var message = jQuery('<div class="gbfdb-message"></div>');
    var wraper = jQuery('.save_form_ip_wrap');
    if(typeof data_response === 'object'){
        if("success" in data_response){
            if(data_response['success']){
                message.append('<i>Success</i>');
                message.addClass("notice notice-success");
            }else{
                message.append('<i>Error</i>');
                message.append('<br />');
                message.append('<span>Check your console for the response.</span>');
                message.addClass("error");
                console.log(data_response);
            }
        }else{
            message.append('<i>Error</i>');
            message.append('<br />');
            message.append('<span>Check your console for the response.</span>');
            message.addClass("error");
            console.log(data_response);
        }
    }else{
        message.append('<i>Error</i>');
        message.append('<br />');
        message.append('<span>Check your console for the response.</span>');
        message.addClass("error");
        console.log(data_response);
    }

    wraper.append(message);
}

function gbfdb_save_svg(){
    if(jQuery('#gbfdb-cvs-forms option:selected').is('[value]')){
        var full_list = jQuery('.gbfdb-leads-wrap').find("ul.gbfdb-leads-list");
        var data = [];
        var head = [];
        var rows = {};
        var form_id = jQuery('#gbfdb-cvs-forms').val();
        full_list.find('.gbfdb-fields-item[data-form-id="'+form_id+'"]').closest('.gbfdb-fields-list').each(function(index,list){
            jQuery(list).find('li').each(function(li_index,li_value){
                if(!jQuery(li_value).is('.geeky-stuff') && !jQuery(li_value).is('.system') && !jQuery(li_value).is('.created-date')){
                    var key = '';
                    if(jQuery(li_value).find('label.field-title').length){
                        key = jQuery(li_value).find('label.field-title').html().trim();
                        if(!head.includes(key) && key.trim().length){
                            head.push(key);
                        }
                        if(index in rows){
                            rows[index].push((jQuery(li_value).find('input.gbfdb-field').attr('value').trim().length ? jQuery(li_value).find('input.gbfdb-field').attr('value').trim() : '0'));
                        }else{
                            rows[index] = [];
                            rows[index].push((jQuery(li_value).find('input.gbfdb-field').attr('value').trim().length ? jQuery(li_value).find('input.gbfdb-field').attr('value').trim() : '0'));
                        }
                    }else if(jQuery(li_value).find('label.key').length){
                        key = jQuery(li_value).find('label.key').html().trim();
                        if(!head.includes(key)){
                            head.push(key);
                        }
                        if(index in rows){
                            rows[index].push((jQuery(li_value).find('label.meta').html().trim().replace(/<[^>]*>?/gm, '').length ? jQuery(li_value).find('label.meta').html().trim().replace(/<[^>]*>?/gm, '') : '0'));
                        }else{
                            rows[index] = [];
                            rows[index].push((jQuery(li_value).find('label.meta').html().trim().replace(/<[^>]*>?/gm, '').length ? jQuery(li_value).find('label.meta').html().trim().replace(/<[^>]*>?/gm, '') : '0'));
                        }
                    }
                }
            });
        });
        if(head.length > 0 && Object.keys(rows).length > 0){
            data.push(head);
            jQuery.each(rows,function(index,val){
                if(Array.isArray(val) && val.length == head.length){
                    data.push(val);
                }
            });
        }
        if(data.length > 0){
            var csv = "";
            data.forEach(function(row) {
                for (var i in row) {
                    csv += row[i] + ",";
                }
                csv.substring(0, csv.length-1);
                csv += "\n";
            });

            var hiddenElement = document.createElement('a');
            hiddenElement.href = 'data:text/csv;charset=utf-8,' + encodeURI(csv);
            hiddenElement.target = '_blank';
            hiddenElement.download = 'GBFDB-leads.csv';
            hiddenElement.click();
        }else{
            alert("Error: No data found.");
        }

    }
}

function gbfdb_init(){
    if(jQuery('#gbfdb-date-from').length){
        jQuery('#gbfdb-date-from').datepicker({
            dateFormat : 'mm/dd/yy'
        });
        jQuery('#gbfdb-date-to').datepicker({
            dateFormat : 'mm/dd/yy'
        });
    }

    if(jQuery('#gbfdb-view-form').length && jQuery('.gbfdb-lead-form-id').length){
        var forms_id = {};
        jQuery('.gbfdb-lead-form-id').each(function(){
            var id = jQuery(this).find('label.field-label').html().trim();
            if(!(id in forms_id)){
                forms_id[id] = id;
            }
            jQuery(this).attr("data-form-id",id);
        });
        jQuery.each(forms_id,function(index,val){
            jQuery('#gbfdb-view-form').append('<option value="'+val+'">'+val+'</option>');
        });
        if(jQuery('#gbfdb-cvs-forms').length){
            jQuery.each(forms_id,function(index,val){
                jQuery('#gbfdb-cvs-forms').append('<option value="'+val+'">'+val+'</option>');
            });
        }
    }

    if(jQuery('.gbfdb-checkbox').length){
        jQuery('.gbfdb-checkbox').find('input[type="checkbox"]').each(function(){
            if(jQuery(this).is('#show_system_fields')){
                var system_field = jQuery(this);
                setTimeout(function(){
                    system_field.prop('checked',false);
                    gbfdb_checkbox_change(system_field);
                    open_gbfdb_leads();
                },400);
            }
        });
    }else{
        open_gbfdb_leads();
    }


}

function gbfdb_filter_reset(){
    jQuery(".gbfdb-leads-list").find("li.lead.hide").removeClass("hide");
}

function gbfdb_filter_text(search_btn){
    var wrap = search_btn.closest('.field-wrap');
    if(wrap.find(".gbfdb-field").length){
        wrap.find(".gbfdb-field").each(function(){
            var letters = jQuery(this).val();
            if(letters){
                //add case for each input

                //text period
                if(jQuery(this).is('#gbfdb-view-period')){
                    if(letters != 'period'){
                        gbfdb_lead_period_search(letters);
                    }
                }

                //form id search
                if(jQuery(this).is('#gbfdb-view-form')){
                    gbfdb_lead_form_id_search(letters);
                }

                //text search
                if(jQuery(this).is('#gbfdb-lead-text')){
                    gbfdb_lead_text_search(letters);
                }

                //field & value search
                if(jQuery(this).is('#gbfdb-field-val-title')){
                    var text = wrap.find("#gbfdb-field-val-text").val();
                    if(text){
                        gbfdb_lead_field_search(letters,text);
                    }
                }

                //date search
                if(jQuery(this).is('#gbfdb-date-from')){
                    var to = wrap.find("#gbfdb-date-to").val();
                    if(to){
                        gbfdb_lead_date_search(letters,to);
                    }
                }
            }
        });
    }
}

//Thank you https://stackoverflow.com/questions/2536379/difference-in-months-between-two-dates-in-javascript
function gbfdb_monthDiff(d1, d2) {
    var months;
    months = (d2.getFullYear() - d1.getFullYear()) * 12;
    months -= d1.getMonth() + 1;
    months += d2.getMonth();
    return months <= 0 ? 0 : months;
}

//text period
function gbfdb_lead_period_search(val) {
    if(isNaN(val)){
        return;
    }
    var today = new Date();
    if(jQuery('.gbfdb-fields-list').length){
        jQuery('.gbfdb-fields-list').each(function(){
            if(jQuery(this).find('li').length){
                var is = false;
                jQuery(this).find('li').each(function(){
                    if(jQuery(this).is(".created-date[data-date]") && jQuery(this).attr("data-date") != ""){
                        var lead_date = new Date(jQuery(this).attr("data-date"));
                        if(gbfdb_monthDiff(lead_date,today) <= parseInt(val)){
                            is = true;
                        }
                    }
                });
                if(!is){
                    jQuery(this).closest("li.lead").addClass('hide');
                }else{
                    if(jQuery(this).closest("li.lead").is('.hide')){
                        jQuery(this).closest("li.lead").removeClass('hide');
                    }
                }
            }
        });
    }
}

//form id
function gbfdb_lead_form_id_search(val) {
    if(jQuery('.gbfdb-fields-list').length){
        jQuery('.gbfdb-fields-list').each(function(){
            if(jQuery(this).find('li.gbfdb-lead-form-id').length){
                var is = false;

                if(jQuery(this).find('li.gbfdb-lead-form-id').attr('data-form-id') == val){
                    is = true;
                }

                if(!is){
                    jQuery(this).closest("li.lead").addClass('hide');
                }else{
                    if(jQuery(this).closest("li.lead").is('.hide')){
                        jQuery(this).closest("li.lead").removeClass('hide');
                    }
                }
            }
        });
    }
}

//text search
function gbfdb_lead_text_search(val) {
    if(jQuery('.gbfdb-fields-list').length){
        jQuery('.gbfdb-fields-list').each(function(){
            if(jQuery(this).find('li').length){
                var is = false;
                jQuery(this).find('li').each(function(){
                    if(jQuery(this).find(".field-label:contains('"+val+"')").length){
                        is = true;
                    }else if(jQuery(this).find(".meta:contains('"+val+"')").length){
                        is = true;
                    }
                });
                if(!is){
                    jQuery(this).closest("li.lead").addClass('hide');
                }else{
                    if(jQuery(this).closest("li.lead").is('.hide')){
                        jQuery(this).closest("li.lead").removeClass('hide');
                    }
                }
            }
        });
    }
}

//field search
function gbfdb_lead_field_search(field,val) {
    if(jQuery(".field-title:contains('"+field+"')").length || jQuery("label.key:contains('"+field+"')").length){
        jQuery('.gbfdb-fields-list').each(function(){
            if(jQuery(this).find('li').length){
                var is = false;
                jQuery(this).find('li').each(function(){
                    if(jQuery(this).find(".field-title:contains('"+field+"')").length && jQuery(this).find(".field-label:contains('"+val+"')").length){
                        is = true;
                    }else if(jQuery(this).find(".key:contains('"+field+"')").length && jQuery(this).find(".meta:contains('"+val+"')").length){
                        is = true;
                    }
                });
                if(!is){
                    jQuery(this).closest("li.lead").addClass('hide');
                }else{
                    if(jQuery(this).closest("li.lead").is('.hide')){
                        jQuery(this).closest("li.lead").removeClass('hide');
                    }
                }
            }
        });
    }
}

//date search
function gbfdb_lead_date_search(from,to) {
    if(jQuery('.gbfdb-fields-list').length){
        jQuery('.gbfdb-fields-list').each(function(){
            if(jQuery(this).find('li.created-date').length){
                var is = false;
                var date_html = jQuery(this).find('li.created-date').find('.meta').html();
                if(Date.parse ( date_html ) >= Date.parse ( from ) && Date.parse ( date_html ) <= Date.parse ( to )){
                    is = true;
                }

                if(!is){
                    jQuery(this).closest("li.lead").addClass('hide');
                }else{
                    if(jQuery(this).closest("li.lead").is('.hide')){
                        jQuery(this).closest("li.lead").removeClass('hide');
                    }
                }
            }
        });
    }
}

function open_gbfdb_leads(){
    jQuery('.gbfdb-leads-wrap.loading .gbfdb-loader').animate({
        opacity: 0
    },500,function(){
        jQuery('.gbfdb-leads-wrap.loading').removeClass('loading');
        jQuery('.gbfdb-leads-wrap .gbfdb-loader').removeAttr('style');
    });
}


if(document.getElementById('gbfdb-toggle-geeky-stuff')){
    document.getElementById('gbfdb-toggle-geeky-stuff').onclick = function(event){
        event.preventDefault();
        if(document.getElementsByClassName('gbfdb-geeky-stuff-wrap')){
            var geeky_stuff_wrap = document.getElementsByClassName('gbfdb-geeky-stuff-wrap')[0];
            if(geeky_stuff_wrap.classList.contains("close")){
                geeky_stuff_wrap.classList.add("open");
                geeky_stuff_wrap.classList.remove("close");
            }else{
                geeky_stuff_wrap.classList.add("close");
                geeky_stuff_wrap.classList.remove("open");
            }
        }
    };
}

function LoadGBFDBLeads(LeadsViewerArray){
    var strollerWidthWidth = getScrollbarWidth();
    if(strollerWidthWidth >= 10){
        document.body.className += ' ' + 'big-stroller';
    }else{
        document.body.className += ' ' + 'small-stroller';
    }
    document.body.className += ' ' + 'home';


    if(!LeadsViewerArray)
        return;

    for (var main_index = 0; main_index < LeadsViewerArray.length; main_index++){
        var Viewer_id = LeadsViewerArray[main_index].id;

        var LeadsViewer = document.getElementById(Viewer_id);
        if(LeadsViewer){
            LeadsViewer.classList.remove("loading");
            if(document.getElementsByClassName('gbfdb-leads-scroll')){
                var scrollers_element = LeadsViewer.querySelectorAll('.gbfdb-leads-scroll');
                if(scrollers_element.length){
                    for (var i = 0; i < scrollers_element.length; i++) {
                        var scrollers = scrollers_element[i].querySelectorAll('ul.gbfdb-fields-list li');
                        var width = 0;
                        var height = 0;
                        for(var x = 0; x < scrollers.length; x++){
                            if(scrollers[x]){
                                width += scrollers[x].clientWidth;
                                if(scrollers[x].offsetHeight > height){
                                    height = scrollers[x].offsetHeight;
                                }
                            }
                        }
                        scrollers_element[i].style.width = (width + 30)+'px';
                        var closest = gbfdb_closest(scrollers_element[i],'gbfdb-leads-scroll-wrap');
                        if(closest){
                            closest.style.height = (height + strollerWidthWidth)+"px";
                        }
                    }
                }
            }
        }
    }
}

function gbfdb_closest (el, cls) {
    while ((el = el.parentElement) && !el.classList.contains(cls));
    return el;
}

function getScrollbarWidth() {
    return window.innerWidth - document.documentElement.clientWidth;
}

function gbfdb_field_button(button){
    var fields_wrap = jQuery('.gbfdb_api_post_body_fields_wrap');
    var row = button.closest('.field-row');
    var row_index = row.index();

    if(!isNaN(row_index)){
        if(button.is('.add')){
            var new_index = row_index + 1;
            var new_row = get_row_next_to(row);
            fields_wrap.find('li.field-row').eq(row.index()).after(new_row);
        }else if(button.is('.remove')){
            if(fields_wrap.find('li.field-row').length > 1){
                var remove_row = button.closest('.field-row');
                remove_row.remove();
            }
        }
        gbfdb_reset_rows();
    }
}
function gbfdb_reset_rows(){
    var fields_wrap = jQuery('.gbfdb_api_post_body_fields_wrap');
    var index = 0;
    fields_wrap.find('li.field-row').each(function(){
        jQuery(this).find('input').each(function(){
            if(jQuery(this).attr('id')){
                var row_id = jQuery(this).attr('id');
                var roe_id_num = row_id.substring(row_id.length - 1);
                if(!isNaN(roe_id_num)){
                    if(index != roe_id_num){
                        jQuery(this).attr('id',row_id.substring(0,row_id.length - 1) + index);
                    }
                }
            }
        });
        index++;
    });
}

//clone the row and change the ids with index
function get_row_next_to(row){
    var new_row = row.clone();
    jQuery(new_row).find('input').each(function(){
        if(jQuery(this).attr('id')){
            var new_id = jQuery(this).attr('id');
            var id_num = new_id.substring(new_id.length - 1);
            if(!isNaN(id_num)){
                jQuery(this).attr('id',new_id.substring(0,new_id.length - 1) + (parseInt(id_num) + 1));
            }else{
                jQuery(this).removeAttr('id');
            }
        }
    });
    return jQuery(new_row);
}

